unit uMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,libusb, Spin, ExtCtrls, Buttons,Math,adCpuUsage, ComCtrls;

type
  TDevObj = class(TObject)
  public
    Serial:string;
    hDev:pusb_device;
  end;

type
  TForm1 = class(TForm)
    Button1: TButton;
    cmdClear: TButton;
    Memo1: TMemo;
    oListe: TListBox;
    Geraete: TLabel;
    Servo1: TButton;
    Wert1: TSpinEdit;
    Servo2: TButton;
    Wert2: TSpinEdit;
    Servo3: TButton;
    Wert3: TSpinEdit;
    Servo4: TButton;
    Wert4: TSpinEdit;
    Servo5: TButton;
    Wert5: TSpinEdit;
    Servo6: TButton;
    Wert6: TSpinEdit;
    TrackBar1: TTrackBar;
    TrackBar2: TTrackBar;
    TrackBar3: TTrackBar;
    TrackBar4: TTrackBar;
    TrackBar5: TTrackBar;
    TrackBar6: TTrackBar;
    procedure TrackBar6Change(Sender: TObject);
    procedure TrackBar5Change(Sender: TObject);
    procedure TrackBar4Change(Sender: TObject);
    procedure TrackBar3Change(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);

    procedure Servo6Click(Sender: TObject);
    procedure Servo5Click(Sender: TObject);
    procedure Servo4Click(Sender: TObject);
    procedure Servo3Click(Sender: TObject);
    procedure Servo2Click(Sender: TObject);
    procedure Servo1Click(Sender: TObject);
    procedure cmdClearClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);

  end;

var
  Form1: TForm1;

const
  VENDORID = $03eb;
  PRODUCTID= $7a53;
  msgOK =0;
  msgErr =1;

implementation

uses StrUtils;

{$R *.dfm}


procedure TForm1.cmdClearClick(Sender: TObject);
var
  buffer:array[0..256] of char;

  devObj:TDevObj;
  hUSB:pointer;

begin

  if (oListe.ItemIndex<0) then
    exit;

  DevObj := TDevObj(oListe.Items.Objects[oListe.ItemIndex]);

  hUSB := usb_open( DevObj.hDev );
  if ( hUSB <> nil ) then begin
    usb_control_msg(hUSB,  USB_TYPE_VENDOR or USB_RECIP_DEVICE or USB_ENDPOINT_IN,
        3, 0, 0, buffer, 0, 1000);
		usb_close( hUSB );
	end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  foundvendor,foundprodukt:boolean;
  buf:array[0..100] of char;
  bus: pusb_bus;
  l:integer;
  dev: pusb_device;
  DevObj:TDevObj;
  hUSB : pointer;
  ProdStr,Serial:string;
begin
  foundvendor:=false;
  foundprodukt:=false;
  usb_init; // Initialize libusb
  memo1.Lines.Add(usb_strerror);
  if(usb_find_busses<1) then
    showmessage(usb_strerror);

  if (usb_find_devices<1) then
    showmessage(usb_strerror); // Find all devices on all USB devices

  bus := usb_get_busses; // Return the list of USB busses found
  if  bus=nil then
    showmessage(usb_strerror);

  while Assigned(bus) do begin
    dev := bus^.devices;
    while Assigned(dev) do begin
      if dev^.descriptor.idVendor=vendorid  then
        foundvendor:=true;

      if dev^.descriptor.idProduct=productid then
        foundprodukt:=true;

      if (foundvendor and foundprodukt) then begin
        memo1.Lines.add('ObDev-Device: '+bus.dirname+'/'+dev.filename);
        hUSB := usb_open( dev );

        l := usb_get_string_simple(hUSB,dev.descriptor.iManufacturer,buf,100);
        if l>0 THEN
          memo1.Lines.add('   Hersteller:'+buf);

        l := usb_get_string_simple(hUSB,dev.descriptor.iProduct,buf,100);

        if l>0 THEN begin
          memo1.Lines.add('   Produkt   :'+buf);
          prodStr :=buf;
        end;

        l := usb_get_string_simple(hUSB,dev.descriptor.iSerialNumber,buf,100);
        if l>0 then begin
          memo1.Lines.add('   Serien-Nr.:'+buf);
          serial := buf;
        end else
          serial:='xx';

        if prodStr='USB-ROBO' then begin
          DevObj := TDevObj.Create();
          DevObj.Serial := serial;
          DevObj.hDev := dev;
          oListe.Items.AddObject(serial,DevObj);
        end;

        usb_close(hUSB);
      end;

      dev := dev^.next;
    end;

    bus := bus^.next;
  end;

  if not (foundvendor and foundprodukt) then
    showmessage('LCD-USB (VID=0x03eb  PID=0x7a53)'+#10+#13+'Not Found');
end;


procedure TForm1.Servo1Click(Sender: TObject);
var
  hUSB:pointer;
  buffer:array[0..256] of char;
  devObj:TDevObj;

begin

  if (oListe.ItemIndex<0) then
    exit;

  DevObj := TDevObj(oListe.Items.Objects[oListe.ItemIndex]);

  hUSB := usb_open( DevObj.hDev );

  if ( hUSB <> nil ) then begin
    usb_control_msg(hUSB,  USB_TYPE_VENDOR or USB_RECIP_DEVICE or USB_ENDPOINT_IN, 4, 1, Wert1.Value, buffer, 0, 1000);
		usb_close( hUSB );
	end;
end;

procedure TForm1.Servo2Click(Sender: TObject);
var
  hUSB:pointer;
  buffer:array[0..256] of char;
  devObj:TDevObj;

begin

  if (oListe.ItemIndex<0) then
    exit;

  DevObj := TDevObj(oListe.Items.Objects[oListe.ItemIndex]);

  hUSB := usb_open( DevObj.hDev );

  if ( hUSB <> nil ) then begin
    usb_control_msg(hUSB,  USB_TYPE_VENDOR or USB_RECIP_DEVICE or USB_ENDPOINT_IN, 4, 2, Wert2.Value, buffer, 0, 1000);
		usb_close( hUSB );
	end;
end;

procedure TForm1.Servo3Click(Sender: TObject);
var
  hUSB:pointer;
  buffer:array[0..256] of char;
  devObj:TDevObj;

begin

  if (oListe.ItemIndex<0) then
    exit;

  DevObj := TDevObj(oListe.Items.Objects[oListe.ItemIndex]);

  hUSB := usb_open( DevObj.hDev );

  if ( hUSB <> nil ) then begin
    usb_control_msg(hUSB,  USB_TYPE_VENDOR or USB_RECIP_DEVICE or USB_ENDPOINT_IN, 4, 3, Wert3.Value, buffer, 0, 1000);
		usb_close( hUSB );
	end;
end;

procedure TForm1.Servo4Click(Sender: TObject);
var
  hUSB:pointer;
  buffer:array[0..256] of char;
  devObj:TDevObj;

begin

  if (oListe.ItemIndex<0) then
    exit;

  DevObj := TDevObj(oListe.Items.Objects[oListe.ItemIndex]);

  hUSB := usb_open( DevObj.hDev );

  if ( hUSB <> nil ) then begin
    usb_control_msg(hUSB,  USB_TYPE_VENDOR or USB_RECIP_DEVICE or USB_ENDPOINT_IN, 4, 4, Wert4.Value, buffer, 0, 1000);
		usb_close( hUSB );
	end;
end;

procedure TForm1.Servo5Click(Sender: TObject);
var
  hUSB:pointer;
  buffer:array[0..256] of char;
  devObj:TDevObj;

begin

  if (oListe.ItemIndex<0) then
    exit;

  DevObj := TDevObj(oListe.Items.Objects[oListe.ItemIndex]);

  hUSB := usb_open( DevObj.hDev );

  if ( hUSB <> nil ) then begin
    usb_control_msg(hUSB,  USB_TYPE_VENDOR or USB_RECIP_DEVICE or USB_ENDPOINT_IN, 4, 5, Wert5.Value, buffer, 0, 1000);
		usb_close( hUSB );
	end;
end;

procedure TForm1.Servo6Click(Sender: TObject);
var
  hUSB:pointer;
  buffer:array[0..256] of char;
  devObj:TDevObj;

begin

  if (oListe.ItemIndex<0) then
    exit;

  DevObj := TDevObj(oListe.Items.Objects[oListe.ItemIndex]);

  hUSB := usb_open( DevObj.hDev );

  if ( hUSB <> nil ) then begin
    usb_control_msg(hUSB,  USB_TYPE_VENDOR or USB_RECIP_DEVICE or USB_ENDPOINT_IN, 4, 6, Wert6.Value, buffer, 0, 1000);
		usb_close( hUSB );
	end;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
Wert1.Value := TrackBar1.Position;
end;

procedure TForm1.TrackBar2Change(Sender: TObject);
begin
Wert2.Value := TrackBar2.Position;
end;

procedure TForm1.TrackBar3Change(Sender: TObject);
begin
Wert3.Value := TrackBar3.Position;
end;

procedure TForm1.TrackBar4Change(Sender: TObject);
begin
Wert4.Value := TrackBar4.Position;
end;

procedure TForm1.TrackBar5Change(Sender: TObject);
begin
Wert5.Value := TrackBar5.Position;
end;

procedure TForm1.TrackBar6Change(Sender: TObject);
begin
Wert6.Value := TrackBar6.Position;
end;

end.
